package at.compax.tools.sql.model;

import java.util.List;

import com.fasterxml.jackson.annotation.JsonInclude;

import lombok.Builder;
import lombok.Getter;
import lombok.ToString;

@Getter
@Builder
@ToString
@JsonInclude(JsonInclude.Include.NON_NULL)
public class QueryResult {
  @Getter
  @Builder
  @ToString
  @JsonInclude(JsonInclude.Include.NON_NULL)
  public static class ColumnDefinition {
    private int index;
    private String name;
    private String type;
  }

  @Getter
  @Builder
  @ToString
  @JsonInclude(JsonInclude.Include.NON_NULL)
  public static class Row {
    @Getter
    @Builder
    @ToString
    @JsonInclude(JsonInclude.Include.NON_NULL)
    public static class Column {
      private Object value;
    }

    private List<Column> columns;
  }

  private List<ColumnDefinition> columnDefinitions;
  private List<Row> rows;
  private List<UserError> userErrors;
  private String exception;
  private String exceptionMessage;
}
